%define name xmms
%define version 1.2.3
%define prefix %{_prefix}
%define release 4mdk

%define additional_effect_plugin_a sox-effect-0.0.1
%define additional_misc_plugin_a xmms-shell-0.2.2

Name: %{name}
Summary: XMMS - The Sound player with the WinAmp GUI
Version: %{version}
Release: %{release}
Copyright: GPL
Group: Sound
Icon: xmms-logo.xpm
URL: http://www.xmms.org/
Source0: http://www.xmms.org/%{name}-%{version}.tar.bz2

Source2: gnomexmms.desktop.bz2
Source4: %{name}-icons.tar.bz2
Source5: %{name}
Source6: %{name}.xpm.bz2
Source7: %{name}-32.xpm.bz2

Source50: http://staff.xmms.org/zinx/xmms/%{additional_effect_plugin_a}.tar.bz2
Source51: http://xmms-shell.sourceforge.net/%{additional_misc_plugin_a}.tar.bz2

Patch0: xmms-1.0.1-i18n.diff.bz2
Patch1: xmms-1.2.3-xfont.patch.bz2
Patch2: xmms-0.9.5-audio.patch.bz2
Patch3: xmms-1.0.0-latin1_text.diff.bz2
Patch4: xmms-1.2-audio-patch.bz2
Patch5: xmms-fix-default-playlist-font.patch.bz2
Patch6: xmms-fix-compatibility-old-playlist-font.patch.bz2
Patch7: xmms-shell-fix-missing-ncurses.patch.bz2
Patch9: xmms-fix-bootstrap.patch.bz2
Patch10: xmms-fix-smallfiles.patch.bz2
Patch11: xmms-fix-memoryleak.patch.bz2
# legal for the 3dse patch is at the end of this file
Patch50: xmms-1.2.1-3dse-7.patch.bz2
Patch51: xmms-3dse-niqueluisarace.patch.bz2

# (gc) temporary patch; because I'm REAL fed up with this "Visualization Plugins" nonsense translation
Patch100: xmms-patch-fr-translation.patch.bz2

Packager: Guillaume Cottenceau <gc@mandrakesoft.com>
BuildRoot: %{_tmppath}/%{name}-buildroot
Requires: glib >= 1.2.5 gtk+ >= 1.2.8-4mdk
Obsoletes: x11amp

%description
XMMS is a sound player written from scratch. Since it uses the WinAmp GUI, it
can use WinAmp skins, and play mp3s, mods, s3ms, and other formats. It now has
support for input, output, and general plugins, and has also been GPLd.

This package also provides an effect plugin based on Sox and a shell for xmms
in order to command the running xmms from any script/commandline.


%package devel
Summary: XMMS - Development package with static libs and headers
Group: Development/C
Icon: xmms-devel-logo.xpm
Requires: %{name} = %{version}

%description devel
Static libraries and header files required for compiling xmms plugins.

%package esd
Summary: XMMS - ESound output backend
Group: Sound
Icon: xmms-esd-logo.xpm
BuildPreReq: esound-devel
Requires: %{name} = %{version}
Obsoletes: x11amp-esd
Requires: esound >= 0.2.14

%description esd
Output plugin for xmms for use with the esound package

%package gnome
Summary: XMMS - Gnome applet
Group: Graphical desktop/GNOME
Icon: xmms-gnome-logo.xpm
Requires: %{name} = %{version}
Obsoletes: x11amp-gnome

%description gnome
GNOME applet for controlling xmms from the GNOME panel

%package mikmod
Summary: Sound player with the WinAmp GUI, Mikmod output backend
Group: Sound
Icon: xmms-mikmod-logo.xpm
BuildPreReq: libmikmod-devel
Obsoletes: x11amp-mikmod
Requires: %{name} = %{version}
Requires: libmikmod >= 3.1.6

%description mikmod
Input plugin for XMMS to play MODs (.MOD,.XM,.S3M, etc)

%ifarch i386 i486 i586 i686 k6 k7
%package mesa
Summary: XMMS - Visualization plugins that use the Mesa3d library
Group: Sound
Icon: xmms-mesa-logo.xpm
Requires: %{name} = %{version}
BuildPreReq: Mesa-devel

%description mesa
3D Visualization plugins for XMMS that use the Mesa3d library.

%endif

%prep
%setup -q -a 50 -a 51
#%patch0 -p1 -b .i18n
%patch1 -p0
#%patch2 -p1 -b .audio
%patch3 -p1 -b .latin1_text
%patch4 -p0
#%patch5 -p0
#%patch6 -p0
%patch7 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch50 -p1
%patch51 -p1
#%patch100 -p0

%build
rm -rf $RPM_BUILD_ROOT

export CFLAGS="$RPM_OPT_FLAGS `glib-config --cflags` -I/usr/X11R6/include/GL "
%configure
make

cd %{additional_effect_plugin_a}
autoconf
%configure
make
cd ..

cd %{additional_misc_plugin_a}
autoconf
%configure
make
cd ..


%install
rm -rf $RPM_BUILD_ROOT 
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/xmms/Effect
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/xmms/General
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/xmms/Input
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/xmms/Output
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/xmms/Visualization
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/xmms/Skins
mkdir -p $RPM_BUILD_ROOT/%{_docdir}

make DESTDIR=$RPM_BUILD_ROOT prefix=$RPM_BUILD_ROOT/%{_prefix} install

cd %{additional_effect_plugin_a}
%makeinstall libdir=$RPM_BUILD_ROOT/%{_libdir}/xmms/Effect
cd ..

cd %{additional_misc_plugin_a}
%makeinstall PREFIX=$RPM_BUILD_ROOT/%{_prefix}
cd ..

install -m644 $RPM_SOURCE_DIR/xmms-logo.xpm $RPM_BUILD_ROOT/%{_datadir}/xmms/xmms.xpm

# compatibility symlink
[ -r $RPM_BUILD_ROOT%{_libdir}/libxmms.so.1 ] && \
	ln -s libxmms.so.1 $RPM_BUILD_ROOT%{_libdir}/libxmms.so.0


mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/mime-info
cat > ${RPM_BUILD_ROOT}%{_datadir}/mime-info/xmms.keys << EOF
audio/x-mp3:
	open=xmms %f
	view=xmms %f
EOF
chmod 644 ${RPM_BUILD_ROOT}%{_datadir}/mime-info/xmms.keys

mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/pixmaps
if [ ! -r ${RPM_BUILD_ROOT}%{_datadir}/pixmaps/xmms_logo.xpm ]; then
	cp $RPM_SOURCE_DIR/xmms-logo.xpm \
		${RPM_BUILD_ROOT}%{_datadir}/pixmaps/xmms.xpm
fi

# install languages by hand
#for i in $RPM_SOURCE_DIR/%{name}-*pofiles.tar.bz2 ; do
#	 # tar yxkvf $i || :
#	 tar yxvf $i
#done

#for i in po/*.po ; do
#  mkdir -p $RPM_BUILD_ROOT/%{_datadir}/locale/`basename $i .po`/LC_MESSAGES
#  msgfmt -v -o $RPM_BUILD_ROOT/%{_datadir}/locale/`basename $i .po`/LC_MESSAGES/%{name}.mo $i
#done

# menu
mkdir -p $RPM_BUILD_ROOT/%{_menudir}
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT/%{_menudir}

# icons
mkdir -p $RPM_BUILD_ROOT/%{_miconsdir}
bzcat %{SOURCE6} > $RPM_BUILD_ROOT/%{_miconsdir}/%{name}.xpm
bzcat %{SOURCE7} > $RPM_BUILD_ROOT/%{_iconsdir}/%{name}.xpm

%find_lang %{name}


%post
/sbin/ldconfig
%{update_menus}

%postun
/sbin/ldconfig
%{clean_menus}

%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{name}.lang
%defattr(-, root, root)

%doc AUTHORS COPYING ChangeLog INSTALL NEWS README
%dir %{_datadir}/xmms
%dir %{_libdir}/xmms
%{_bindir}/xmms
%{_bindir}/wmxmms
%{_bindir}/xmms-shell
%{_libdir}/libxmms.so.*
%dir %{_libdir}/xmms/Input
%{_libdir}/xmms/Input/libcdaudio*
%{_libdir}/xmms/Input/libmpg123*
%{_libdir}/xmms/Input/libwav*
%{_libdir}/xmms/Input/libidcin*
%dir %{_libdir}/xmms/Output
%{_libdir}/xmms/Output/libOSS*
%{_libdir}/xmms/Output/libdisk_writer*
%dir %{_libdir}/xmms/General
%{_libdir}/xmms/General/*
%dir %{_libdir}/xmms/Effect
%{_libdir}/xmms/Effect/*
%dir %{_libdir}/xmms/Visualization
%{_libdir}/xmms/Visualization/libbscope*
%{_libdir}/xmms/Visualization/libsanalyzer*
%{_datadir}/xmms/wmxmms.xpm
%{_datadir}/xmms/xmms.xpm
%{_iconsdir}/%{name}.xpm
%{_miconsdir}/%{name}.xpm
%{_menudir}/*

%files devel
%defattr(-,root,root)
%doc COPYING FAQ
%{_libdir}/lib*.so
%{_libdir}/lib*.a
%{_libdir}/lib*.la
%{_includedir}/*
%{_datadir}/aclocal/xmms.m4
%{_bindir}/xmms-config

%files esd
%defattr(-, root, root)
%doc COPYING
%{_libdir}/xmms/Output/libesdout*

%files gnome
%defattr(-, root, root)
%doc COPYING
%config(noreplace) /etc/CORBA/servers/*
%{_bindir}/gnomexmms
%{_datadir}/applets/Multimedia/gnomexmms.desktop
%{_datadir}/mime-info/xmms.keys
%{_datadir}/pixmaps/*

%files mikmod
%defattr(-, root, root)
%doc Input/mikmod/COPYING
%{_libdir}/xmms/Input/libmikmod*

%ifarch i386 i486 i586 i686 k6 k7
%files mesa
%defattr(-,root,root)
%doc COPYING
%{_libdir}/xmms/Visualization/libogl_spectrum*
%endif

%changelog
* Fri Oct  6 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.3-4mdk
- patch to fix infinite loop with small files (rh)
- definitive patch to fix memory leak: it seems that this bug comes
  gdk_font_unref that bugs with XFree86-libs-4.x ; fixing it by
  removing the (unecessary) reload of the font each time the playlist
  is redrawn (thanks to pixel)

* Mon Oct  2 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.3-3mdk
- fix bootstrapping for fredl

* Wed Sep 27 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.3-2mdk
- rebuild for soundwrapper and kde_mimetype support, thanks to vince
- seems like it needs the latest gtk+ or it segfaults, thanks to Chmouel
- workaround for memory leak detected while playing ogg vorbis files:
  comment out refresh of playlist

* Sun Sep 24 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.3-1mdk
- 1.2.3 which fixes the memory leak

* Wed Aug 30 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.2-7mdk
- added %config(noreplace)

* Fri Aug 25 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.2-6mdk
- added full url location for included plugins for ease of further
  package manipulation

* Fri Aug 25 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.2-5mdk
- added packager tag

* Wed Aug  9 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.2-4mdk
- added a niqueluisarace patch to 3dse in order to not defaultly focus
  to 3dse when opening the `configure' panel of OSS

* Wed Jul 19 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.2-3mdk
- rebuild for buggy % clean_menus

* Tue Jul 18 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.2-2mdk
- BM
- menu/icons macros

* Wed Jul 12 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.2-1mdk
- 1.2.2 
- ported Chun-Chung Chen xfont patch (a pain)
- patched the french translation of `Visualization Plugins' nonsense

* Tue Jun 27 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.1-3mdk
- added 3DSE patch
- added sox effect plugin
- added xmms-shell misc plugin
- macroization

* Fri Jun 23 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.1-2mdk
- included contrib by <andrew@cle.linux.org.tw> :
    added xmms-1.2.1-xfont.diff by Chun-Chung Chen <cjj@u.washington.edu>

* Tue Jun 20 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.1-1mdk
- 1.2.1 that fixes many bugs

* Tue Jun 13 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.2.0-1mdk
- 1.2.0
- patches:
		i18n patch seems no more necessary (included now)
		big5 patch still needed
		audio.c patch still needed, had to port it to 1.2.0
		latin1_text patch still needed	
- added patch:
		fix default playlist font (was a fontset instead of a font)

* Wed May  3 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0.1-10mdk
- added provides libxmms to enable smooth upgrade of package xmms

* Sat Apr 29 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 1.0.1-9mdk
- added a lot of new and improved translation files from our translator teams
- /usr/share/pixmap -> /usr/share/pixmaps

* Mon Apr 17 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0.1-8mdk
- fixed menu conflict gnome/menu
- added 32x32 icon
- better directory owns

* Mon Apr 10 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0.1-7mdk
- better icon

* Wed Apr  5 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0.1-6mdk
- now shipping xmms-more-vis-plugins and xmms-kjofol-skins as
  separate packages (thx to Pablo)
- minor fixes of warnings

* Thu Mar 23 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0.1-5mdk
- fixed group problem
- fixed missing icon

* Thu Mar 23 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0.1-4mdk
- add menu support
- patched french translation

* Mon Mar 20 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.0.1-3mdk
- add xmms-more-vis-plugins packages
- add kjofol-skins package
- new groups

* Mon Mar 13 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 1.0.1-2mdk
- add xmms-config to devel package or else xmms apps refuse to build
  (reported by Geoffrey Lee <snailtalk@linux-mandrake.com>)
- updated the various language translations

* Fri Feb  4 2000 Andrew Lee <andrew@cle.linux.org.tw> 1.0.1-1mdk
- add Chun-Chung Chen <cjj@u.washington.edu> big5 patch
- update i18n patch, po files and Thanks for jouston@i18n.linux.org.tw
- fix xmms-mesa isn't build
- aclocal
- autoconf

* Thu Feb 03 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 1.0.0-2mdk
- moved skins to its own spec file
- made a libxmms.so.0 compatibility symlink

* Mon Jan 31 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 1.0.0-1mdk
- upodated to 1.0.0 and applied i18N patches
- added patch for 16bits encodings on song names
- xmms-mesa isn't built... why ?

* Sun Jan 23 2000 Pablo Saratxaga <pablo@mandrakesoft.com>
- added Chinese and Catalan interfaces

* Tue Jan 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.9.5.1-9mdk
- use a %_tmpath
 
* Thu Jan 13 2000 Pixel <pixel@mandrakesoft.com>
- libtoolize --force
- fix naughty things done to Input/mikmod/Makefile.in by the i18n patch
- mesa is x86 only (?)

* Wed Dec 08 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- rebuild linking against Mesa 3.1cvs (uses OpenGL naming of libs instead
  of libMesa*.so stuff)
- added German interface

* Fri Nov 19 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- redo the i18n patch with some improvements
- added (beginning of) ukrainian localization

* Thu Nov 04 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- clean files of gnome pkg
- Updated po files from Pablo

* Sun Oct 31 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Enable SMP build/check
- Update Requires

* Tue Oct 12 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- found a solution to the libmp123.so problem ( mmap() should be used
  the code seems broken; by undefining HAVE_MMAP it works)
  Thanks to Giuseppe Ghibo`

* Mon Oct 04 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- added back the i18n support
- and improved the %files sections a bit

* Fri Oct 01 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- updated to 0.9.5.1.

* Sat Sep 25 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- added a check for skin path to avoid duplicate entries.
- added Bill Nottingham's <notting@redhat.com> for opening
  in non-blocking mode.

* Thu Sep 23 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- updated to 0.9.5.
- added skins.

* Tue Jul 20 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- changed the sources to add full i18n support,
- added menus for Gnome
- some (yet incomplete) *.po files
- there is still a big problem with the compiling of Input/mp123/;
  the rules for assembly disappear when calling autoconf (no definitions
  in config.in :-\ ), and I discovered a bug in common.c that made the
  playlist become crazy (why doesn't it showed up on standard 0.9.1 ??)

* Sat Jul 19 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- Rebuilt for libmikmod 3.1.6 compatibily.

* Fri Jul 16 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Reinserting libmikmode (we provide now a libmikmod package).
- Add patch compilation.

* Thu Jul 15 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Fix corba files to point to /etc/CORBA/
- Include applets.
- Removing mikmod (we don't provides libmikmode.)

* Sun Jun 27 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.de>
- Mandrake adaptions

* Fri Apr 09 1999 Lyle Kempler <kempler@utdallas.edu>
- initial version



# -------------------------------
# 3dse patch legal (from the README file of the patch distribution)
#
#
# COPYING
# 	 This is GNU GPL software.
#  	 Use at own risk.
#
# 
# AUTHOR
# 	 Cornelis Frank <Frank.Cornelis@rug.ac.be>
# 
# 
# HOMEPAGE & ONLINE USER MANUAL
# 	 http://studwww.rug.ac.be/~fcorneli/xmms/
#
